]> git.saurik.com Git - apt.git/blame - test/integration/framework
tests: use SHA1 checksum only by default in tests
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
5d76cee1 3EXIT_CODE=0
8c1dd12c 4
68042532
DK
5while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
12 else
13 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
14 fi
15 shift
16done
17export MSGLEVEL="${MSGLEVEL:-3}"
18
8d876415 19# we all like colorful messages
a09f6eb8 20if [ "$MSGCOLOR" != 'NO' ] && [ "$MSGCOLOR" != 'ALWAYS' ]; then
27cb4f6c 21 if [ ! -t 1 ]; then # but check that we output to a terminal
1290422a
DK
22 export MSGCOLOR='NO'
23 fi
24fi
25
26
27if [ "$MSGCOLOR" != 'NO' ]; then
28 CERROR="\033[1;31m" # red
29 CWARNING="\033[1;33m" # yellow
30 CMSG="\033[1;32m" # green
31 CINFO="\033[1;96m" # light blue
32 CDEBUG="\033[1;94m" # blue
33 CNORMAL="\033[0;39m" # default system console color
34 CDONE="\033[1;32m" # green
35 CPASS="\033[1;32m" # green
36 CFAIL="\033[1;31m" # red
37 CCMD="\033[1;35m" # pink
682a3bf7 38fi
8d876415 39
de81b2e2
DK
40msgprintf() {
41 local START="$1"
42 local MIDDLE="$2"
43 local END="$3"
44 shift 3
45 if [ -n "$1" ]; then
46 printf "$START " "$1"
d73840dc 47 shift
de81b2e2 48 while [ -n "$1" ]; do
03aa0847 49 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghs]\)#apt-\1#')"
de81b2e2
DK
50 shift
51 done
52 fi
53 printf "${END}"
2a2a7ef4 54}
de81b2e2
DK
55msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
56msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
57msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
58msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
59msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
60msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
61msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
62msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
63msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
64msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
65msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
3c528b91 66msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
1501a2c9 67msgreportheader() {
68042532 68 if [ -n "$MSGTEST_MSG" ]; then
1501a2c9 69 test "$1" != 'msgfailoutput' || echo
ae7fce5a
DK
70 if [ -n "$MSGTEST_MSGMSG" ]; then
71 echo "$MSGTEST_MSGMSG"
72 fi
22ac12b2 73 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
1501a2c9 74 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
22ac12b2 75 fi
68042532
DK
76 echo -n "$MSGTEST_MSG"
77 unset MSGTEST_MSG
78 fi
1501a2c9
DK
79}
80msgskip() {
81 msgreportheader 'msgskip'
68ba0b7f
DK
82 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
83 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
84}
5229b285 85msgfail() {
1501a2c9 86 msgreportheader 'msgfail'
68042532 87 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
3c528b91 88 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
03aa0847
DK
89 if [ -n "$APT_DEBUG_TESTS" ]; then
90 $SHELL
91 fi
5229b285
DK
92 EXIT_CODE=$((EXIT_CODE+1));
93}
9beb11aa
DK
94MSGGROUP_LEVEL=0
95msggroup() {
96 if [ -n "$1" ]; then
97 if [ $MSGGROUP_LEVEL = 0 ]; then
98 MSGTEST_GRP='NEXT'
99 fi
100 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
101 else
102 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
103 if [ $MSGGROUP_LEVEL = 0 ]; then
104 unset MSGTEST_GRP
105 fi
106 fi
107}
8d876415
DK
108
109# enable / disable Debugging
fc89263e
DK
110if [ $MSGLEVEL -le 0 ]; then
111 msgdie() { true; }
112fi
113if [ $MSGLEVEL -le 1 ]; then
114 msgwarn() { true; }
115 msgnwarn() { true; }
116fi
117if [ $MSGLEVEL -le 2 ]; then
ae7fce5a
DK
118 msgmsg() {
119 MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")"
120 }
fc89263e 121 msgnmsg() { true; }
9beb11aa
DK
122 msgtest() {
123 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
124 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
125 MSGTEST_GRP="$MSGTEST_MSG"
126 fi
127 }
3c528b91 128 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
fc89263e
DK
129fi
130if [ $MSGLEVEL -le 3 ]; then
131 msginfo() { true; }
132 msgninfo() { true; }
133fi
134if [ $MSGLEVEL -le 4 ]; then
135 msgdebug() { true; }
136 msgndebug() { true; }
137fi
138msgdone() {
139 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
140 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
141 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
142 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
143 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
144 true;
145 else
3c528b91 146 printf "${CDONE}DONE${CNORMAL}\n";
fc89263e
DK
147 fi
148}
e43a426e
MV
149getaptconfig() {
150 if [ -f ./aptconfig.conf ]; then
5465192b 151 echo "$(readlink -f ./aptconfig.conf)"
e43a426e 152 elif [ -f ../aptconfig.conf ]; then
5465192b
DK
153 echo "$(readlink -f ../aptconfig.conf)"
154 elif [ -f ../../aptconfig.conf ]; then
155 echo "$(readlink -f ../../aptconfig.conf)"
156 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
157 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
158 fi
e43a426e 159}
8d876415
DK
160runapt() {
161 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
846856f4
DK
162 local CMD="$1"
163 shift
3b8eb3bc 164 case $CMD in
a311fb96 165 sh|aptitude|*/*|command) ;;
3b8eb3bc
DK
166 *) CMD="${BUILDDIRECTORY}/$CMD";;
167 esac
a311fb96 168 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} $CMD "$@"
8d876415 169}
846856f4
DK
170aptconfig() { runapt apt-config "$@"; }
171aptcache() { runapt apt-cache "$@"; }
172aptcdrom() { runapt apt-cdrom "$@"; }
173aptget() { runapt apt-get "$@"; }
174aptftparchive() { runapt apt-ftparchive "$@"; }
175aptkey() { runapt apt-key "$@"; }
176aptmark() { runapt apt-mark "$@"; }
4f6d26b4 177aptsortpkgs() { runapt apt-sortpkgs "$@"; }
796673c3 178apt() { runapt apt "$@"; }
3b8eb3bc
DK
179apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
180aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
181aptitude() { runapt aptitude "$@"; }
8d50b63f 182aptextracttemplates() { runapt apt-extracttemplates "$@"; }
3082603f 183aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
ad7e0941 184aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
3b8eb3bc 185
158fda31 186dpkg() {
b0be0e09 187 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
158fda31 188}
ce7f128c
DK
189dpkgcheckbuilddeps() {
190 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
b6b5a542 191}
3fa950f1 192gdb() {
b07aeb1a
DK
193 local CMD
194 case "$1" in
195 aptget) CMD="apt-get";;
196 aptcache) CMD="apt-cache";;
5465192b
DK
197 aptcdrom) CMD="apt-cdrom";;
198 aptconfig) CMD="apt-config";;
b07aeb1a
DK
199 aptmark) CMD="apt-mark";;
200 apthelper) CMD="apt-helper";;
3d8232bf 201 aptftparchive) CMD="apt-ftparchive";;
921a9626 202 dpkg) shift; runapt ${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg "$@"; return;;
b07aeb1a
DK
203 *) CMD="$1";;
204 esac
ce928105 205 shift
921a9626
DK
206 if [ "${CMD##*/}" = "$CMD" ]; then
207 CMD="${BUILDDIRECTORY}/${CMD}"
208 fi
209 runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@"
ae99ce2e 210}
8d876415 211
8c1dd12c 212exitwithstatus() {
f91bd741
MV
213 # error if we about to overflow, but ...
214 # "255 failures ought to be enough for everybody"
5d76cee1
MV
215 if [ $EXIT_CODE -gt 255 ]; then
216 msgdie "Total failure count $EXIT_CODE too big"
f91bd741 217 fi
5d76cee1 218 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
8c1dd12c
MV
219}
220
804d4a0d
DK
221shellsetedetector() {
222 local exit_status=$?
223 if [ "$exit_status" != '0' ]; then
3c528b91 224 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
804d4a0d
DK
225 if [ "$EXIT_CODE" = '0' ]; then
226 EXIT_CODE="$exit_status"
227 fi
228 fi
229}
230
b720d0bd 231addtrap() {
8437b7d4
DK
232 if [ "$1" = 'prefix' ]; then
233 CURRENTTRAP="$2 $CURRENTTRAP"
234 else
235 CURRENTTRAP="$CURRENTTRAP $1"
236 fi
804d4a0d 237 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 238}
8d876415
DK
239
240setupenvironment() {
0d303f17
DK
241 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
242 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
243 unset TMPDIR
244 fi
75954ae2 245 TMPWORKINGDIRECTORY=$(mktemp -d)
5684f71f 246 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
68042532 247 msgninfo "Preparing environment for $(basename $0) in ${TMPWORKINGDIRECTORY}…"
5c0dd6fc 248
03aa0847 249 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
250 if [ "$(id -u)" = '0' ]; then
251 # relax permissions so that running as root with user switching works
252 umask 022
03aa0847
DK
253 chmod 711 "$TMPWORKINGDIRECTORY"
254 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
255 fi
256
5684f71f 257 TESTDIRECTORY=$(readlink -f $(dirname $0))
5c0dd6fc 258 # allow overriding the default BUILDDIR location
e8fb1cdf 259 SOURCEDIRECTORY=${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}
5c0dd6fc 260 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
3b8eb3bc 261 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
5c0dd6fc 262 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
e43a426e 263 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
c035b655 264 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
3082603f 265 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
ad7e0941 266 APTDUMPSOLVER=${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}
8d876415 267 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
5c0dd6fc
MV
268 # -----
269
8d876415 270 cd $TMPWORKINGDIRECTORY
cd725954 271 mkdir rootdir aptarchive keys
8d876415 272 cd rootdir
b29c3712 273 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
8fe964f1 274 mkdir -p usr/bin var/cache var/lib var/log tmp
cffea9af 275 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 276 touch var/lib/dpkg/available
8d876415 277 mkdir -p usr/lib/apt
9082a1fc 278 ln -s ${METHODSDIR} usr/lib/apt/methods
1f6cf9e7
DK
279 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
280 mkdir -p usr/lib/apt/solvers
281 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
282 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
283 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
284 fi
291a386f
MV
285 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
286 # system
287 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
288 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
289 else
290 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
291 fi
8d876415 292 cd ..
2c6baa5a 293 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
53ea1b56
DK
294 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
295 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 296 fi
4a4ea26c 297 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
53ea1b56
DK
298 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
299 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 300 fi
53ea1b56 301 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
5684f71f 302 chmod 644 $(find keys -name '*.pub' -o -name '*.sec')
cd725954 303 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
d6cf2345 304
cffea9af 305 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 306 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415 307 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
9d2a8a73 308 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
68ba0b7f
DK
309 # store apt-key were we can access it, even if we run it as a different user
310 # destroys coverage reporting though, so just do it for root for now
311 if [ "$(id -u)" = '0' ]; then
312 cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
313 chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
314 echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
315 else
316 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
317 fi
b0be0e09 318
d61960d9 319 cat << EOF > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
b0be0e09
DK
320#!/bin/sh
321set -e
322if [ -r "${TMPWORKINGDIRECTORY}/noopchroot.so" ]; then
323 if [ -n "\$LD_PRELOAD" ]; then
324 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so \${LD_PRELOAD}"
325 else
326 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so"
327 fi
328fi
921a9626
DK
329exec fakeroot ${DPKG:-dpkg} --root="${TMPWORKINGDIRECTORY}/rootdir" \\
330 --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log \\
331 --force-not-root --force-bad-path "\$@"
332EOF
333 cat << EOF > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
334#!/bin/sh
335set -e
336if [ -r "${TMPWORKINGDIRECTORY}/noopchroot.so" ]; then
337 if [ -n "\$LD_PRELOAD" ]; then
338 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so \${LD_PRELOAD}"
339 else
340 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so"
341 fi
342fi
343exec fakeroot gdb --quiet -ex run "${DPKG:-dpkg}" --args "${DPKG:-dpkg}" --root="${TMPWORKINGDIRECTORY}/rootdir" \\
b0be0e09
DK
344 --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log \\
345 --force-not-root --force-bad-path "\$@"
346EOF
921a9626 347 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
b0be0e09
DK
348 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
349
533fe3d1
DK
350 {
351 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
352 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
353 fi
354 echo 'quiet::NoUpdate "true";'
355 echo 'quiet::NoStatistic "true";'
356 # too distracting for users, but helpful to detect changes
357 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
358 echo 'Acquire::Progress::Diffpercent "true";'
359 # in testcases, it can appear as if localhost has a rotation setup,
360 # hide this as we can't really deal with it properly
361 echo 'Acquire::Failure::ShowIP "false";'
362 } >> aptconfig.conf
d6cf2345 363
68ba0b7f
DK
364 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
365 if [ "$(id -u)" = '0' ]; then
366 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
367 fi
368 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
d6cf2345 369 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
276e51dd 370 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
c5ede4ca 371 confighashes 'SHA1' # these are tests, not security best-practices
77a45beb 372
4bb006d1
DK
373 # create some files in /tmp and look at user/group to get what this means
374 TEST_DEFAULT_USER="$USER"
375 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
376 TEST_DEFAULT_GROUP='root'
377 else
378 TEST_DEFAULT_GROUP="$USER"
379 fi
380
d4f4bcf7
MV
381 # Acquire::AllowInsecureRepositories=false is not yet the default
382 # but we want it to be the default soon
383 configallowinsecurerepositories "false";
384
ce7f128c 385 # cleanup the environment a bit
8c617819
MV
386 # prefer our apt binaries over the system apt binaries
387 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
be233796 388 export LC_ALL=C.UTF-8
3b8eb3bc 389 unset LANGUAGE APT_CONFIG
ce7f128c 390 unset GREP_OPTIONS DEB_BUILD_PROFILES
8d876415
DK
391 msgdone "info"
392}
393
ea65d079
DK
394getarchitecture() {
395 if [ "$1" = "native" -o -z "$1" ]; then
396 eval `aptconfig shell ARCH APT::Architecture`
397 if [ -n "$ARCH" ]; then
398 echo $ARCH
399 else
5834d7a1 400 dpkg --print-architecture
ea65d079
DK
401 fi
402 else
403 echo $1
404 fi
405}
406
53ea1b56 407getarchitectures() {
081c9d44 408 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
53ea1b56
DK
409}
410
3dcdc1f9
DK
411getarchitecturesfromcommalist() {
412 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
413}
414
8d876415 415configarchitecture() {
18908589
DK
416 {
417 echo "APT::Architecture \"$(getarchitecture $1)\";"
418 while [ -n "$1" ]; do
419 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
420 shift
421 done
422 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
53ea1b56
DK
423 configdpkg
424}
425
426configdpkg() {
427 if [ ! -e rootdir/var/lib/dpkg/status ]; then
428 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
429 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
430 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
431 else
432 echo -n > rootdir/var/lib/dpkg/status
433 fi
434 fi
18908589 435 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
846856f4 436 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
53ea1b56
DK
437 local ARCHS="$(getarchitectures)"
438 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
439 DPKGARCH="$(dpkg --print-architecture)"
440 for ARCH in ${ARCHS}; do
feae193b 441 if [ "${ARCH}" != "${DPKGARCH}" ]; then
18908589 442 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
feae193b 443 # old-style used e.g. in Ubuntu-P – and as it seems travis
18908589
DK
444 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
445 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
feae193b
DK
446 fi
447 fi
53ea1b56
DK
448 done
449 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
450 # dpkg doesn't really check the version as long as it is fully installed,
451 # but just to be sure we choose one above the required version
452 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
453 fi
454 fi
455 fi
8d876415
DK
456}
457
0c787570
DK
458configdpkgnoopchroot() {
459 # create a library to noop chroot() and rewrite maintainer script executions
460 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
461 # chroot directory dpkg could chroot into to execute the maintainer scripts
462 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
463 cat << EOF > noopchroot.c
464#define _GNU_SOURCE
465#include <stdio.h>
466#include <stdlib.h>
467#include <string.h>
468#include <dlfcn.h>
469
470static char * chrootdir = NULL;
471
472int chroot(const char *path) {
473 printf("WARNING: CHROOTing to %s was ignored!\n", path);
474 free(chrootdir);
475 chrootdir = strdup(path);
476 return 0;
477}
478int execvp(const char *file, char *const argv[]) {
479 static int (*func_execvp) (const char *, char * const []) = NULL;
480 if (func_execvp == NULL)
481 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
482 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
483 return func_execvp(file, argv);
484 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
485 char newfile[strlen(chrootdir) + strlen(file)];
486 strcpy(newfile, chrootdir);
487 strcat(newfile, file);
b0be0e09
DK
488 char const * const baseadmindir = "/var/lib/dpkg";
489 char admindir[strlen(chrootdir) + strlen(baseadmindir)];
490 strcpy(admindir, chrootdir);
491 strcat(admindir, baseadmindir);
492 setenv("DPKG_ADMINDIR", admindir, 1);
0c787570
DK
493 return func_execvp(newfile, argv);
494}
495EOF
496 testsuccess --nomsg gcc -fPIC -shared -o noopchroot.so noopchroot.c -ldl
0c787570
DK
497}
498
d4f4bcf7
MV
499configallowinsecurerepositories() {
500 echo "Acquire::AllowInsecureRepositories \"$1\";" > rootdir/etc/apt/apt.conf.d/allow-insecure-repositories.conf
501
502}
503
276e51dd
DK
504configcompression() {
505 while [ -n "$1" ]; do
506 case "$1" in
3c528b91
MO
507 '.') printf ".\t.\tcat\n";;
508 'gz') printf "gzip\tgz\tgzip\n";;
509 'bz2') printf "bzip2\tbz2\tbzip2\n";;
510 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
511 'xz') printf "xz\txz\txz\n";;
512 *) printf "$1\t$1\t$1\n";;
276e51dd
DK
513 esac
514 shift
515 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
516}
c5ede4ca
DK
517confighashes() {
518 {
519 echo 'APT::FTPArchive {'
520 {
521 while [ -n "$1" ]; do
522 printf "$1" | tr 'a-z' 'A-Z'
523 printf "\t\"true\";\n"
524 shift
525 done
526 for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do
527 printf "$h\t\"false\";\n"
528 done
529 } | awk '!x[$1]++'
530 echo '};'
531 } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf"
532}
5f982b9d
DK
533forcecompressor() {
534 COMPRESSOR="$1"
535 COMPRESSOR_CMD="$1"
536 case $COMPRESSOR in
537 gzip) COMPRESS='gz';;
538 bzip2) COMPRESS='bz2';;
539 lzma) COMPRESS='lzma';;
540 xz) COMPRESS='xz';;
541 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
542 esac
543 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
544 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
545Dir::Bin::uncompressed \"/does/not/exist\";
546Dir::Bin::gzip \"/does/not/exist\";
547Dir::Bin::bzip2 \"/does/not/exist\";
548Dir::Bin::lzma \"/does/not/exist\";
549Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
550 if [ -e "/bin/${COMPRESSOR}" ]; then
551 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
552 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
553 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
554 elif [ "${COMPRESSOR}" = 'lzma' ]; then
555 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
556 COMPRESSOR_CMD='xz --format=lzma'
557 else
558 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
68042532 559 msgfail "${COMPRESSOR} not available"
5f982b9d
DK
560 fi
561}
562
75954ae2 563setupsimplenativepackage() {
ce9864a8
DK
564 local NAME="$1"
565 local ARCH="$2"
566 local VERSION="$3"
567 local RELEASE="${4:-unstable}"
568 local DEPENDENCIES="$5"
14109555 569 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
570 If you find such a package installed on your system,
571 something went horribly wrong! They are autogenerated
572 und used only by testcases and surf no other propose…"}"
573
b7899b00
DK
574 local SECTION="${7:-others}"
575 local DISTSECTION
576 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
577 DISTSECTION="main"
578 else
579 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
580 fi
ce9864a8
DK
581 local BUILDDIR=incoming/${NAME}-${VERSION}
582 mkdir -p ${BUILDDIR}/debian/source
583 cd ${BUILDDIR}
584 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
585 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
586 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
587
588 * Initial release
589
b7899b00
DK
590 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
591 test -e debian/control || echo "Source: $NAME
592Section: $SECTION
ce9864a8
DK
593Priority: optional
594Maintainer: Joe Sixpack <joe@example.org>
595Build-Depends: debhelper (>= 7)
596Standards-Version: 3.9.1
597
875bcb36
DK
598Package: $NAME" > debian/control
599 if [ "$ARCH" = 'all' ]; then
600 echo "Architecture: all" >> debian/control
601 else
602 echo "Architecture: any" >> debian/control
603 fi
ce9864a8 604 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
18908589
DK
605 echo "Description: $DESCRIPTION" >> debian/control
606
b7899b00
DK
607 test -e debian/compat || echo "7" > debian/compat
608 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 609 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
610 cd - > /dev/null
611}
612
613buildsimplenativepackage() {
614 local NAME="$1"
d56e2917
DK
615 local NM
616 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
617 NM="$(echo "$NAME" | cut -c 1-4)"
618 else
619 NM="$(echo "$NAME" | cut -c 1)"
620 fi
75954ae2
DK
621 local ARCH="$2"
622 local VERSION="$3"
623 local RELEASE="${4:-unstable}"
624 local DEPENDENCIES="$5"
14109555 625 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
626 If you find such a package installed on your system,
627 something went horribly wrong! They are autogenerated
628 und used only by testcases and surf no other propose…"}"
629
75954ae2 630 local SECTION="${7:-others}"
d67004e0 631 local PRIORITY="${8:-optional}"
42c1513b 632 local FILE_TREE="$9"
adff049d 633 local COMPRESS_TYPE="${10:-gzip}"
75954ae2
DK
634 local DISTSECTION
635 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
636 DISTSECTION="main"
637 else
638 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
639 fi
5a635ee4 640 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 641
0c787570 642 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
b761356f
DK
643 mkdir -p $BUILDDIR/debian/source
644 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
645 echo "#!/bin/sh
646echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
647
648 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
649 echo "$NAME ($VERSION) $RELEASE; urgency=low
650
651 * Initial release
652
653 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
654 echo "Source: $NAME
d67004e0 655Priority: $PRIORITY
b761356f 656Maintainer: Joe Sixpack <joe@example.org>
01f520ce 657Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
3cbeed98
DK
658 if [ "$SECTION" != '<none>' ]; then
659 echo "Section: $SECTION" >> ${BUILDDIR}/debian/control
660 fi
01f520ce
DK
661 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
662 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
663 echo "
664Package: $NAME" >> ${BUILDDIR}/debian/control
b761356f 665
875bcb36
DK
666 if [ "$ARCH" = 'all' ]; then
667 echo "Architecture: all" >> ${BUILDDIR}/debian/control
668 else
669 echo "Architecture: any" >> ${BUILDDIR}/debian/control
670 fi
01f520ce
DK
671 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
672 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
18908589 673 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
01f520ce 674
b761356f 675 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
0c787570
DK
676 cd ${BUILDDIR}/..
677 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
678 cd - >/dev/null
679 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output \
f1828b69 680 | while read SRC; do
5a635ee4 681 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
f1828b69 682# if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
33a22672 683# aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
bd7fb5aa 684# adv --yes --default-key 'Joe Sixpack' \
f1828b69
DK
685# --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
686# mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
687# fi
b761356f 688 done
84aa13f4 689
3dcdc1f9 690 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
0c787570 691 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
84aa13f4
DK
692 rm -rf ${BUILDDIR}/debian/tmp
693 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
694 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
695 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
42c1513b
MV
696 if [ -n "$FILE_TREE" ]; then
697 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
698 fi
42c1513b 699
84aa13f4
DK
700 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
701 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
846856f4 702 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
d56e2917 703 # ensure the right permissions as dpkg-deb insists
eb9dee96 704 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
0c787570 705 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/..
84aa13f4
DK
706 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
707 done
708
d56e2917
DK
709 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
710 mkdir -p $CHANGEPATH
711 cp ${BUILDDIR}/debian/changelog $CHANGEPATH
5a635ee4 712 rm -rf "${BUILDDIR}"
b761356f 713 msgdone "info"
75954ae2
DK
714}
715
716buildpackage() {
717 local BUILDDIR=$1
718 local RELEASE=$2
719 local SECTION=$3
ea65d079 720 local ARCH=$(getarchitecture $4)
846856f4
DK
721 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
722 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
0c787570 723 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
75954ae2
DK
724 cd $BUILDDIR
725 if [ "$ARCH" = "all" ]; then
726 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
727 fi
0c787570
DK
728 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
729 cp ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output $BUILDLOG
846856f4
DK
730 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
731 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 732 cd - > /dev/null
b7899b00 733 for PKG in $PKGS; do
75954ae2 734 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
735 done
736 for SRC in $SRCS; do
75954ae2 737 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 738 done
ce9864a8
DK
739}
740
741buildaptarchive() {
ce9864a8 742 if [ -d incoming ]; then
846856f4 743 buildaptarchivefromincoming "$@"
ce9864a8 744 else
846856f4 745 buildaptarchivefromfiles "$@"
ce9864a8
DK
746 fi
747}
748
749createaptftparchiveconfig() {
276e51dd 750 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
016bea82
DK
751 local COMPRESSORS="${COMPRESSORS%* }"
752 local ARCHS="$(getarchitectures)"
c5ede4ca
DK
753 cat > ftparchive.conf <<EOF
754Dir {
755 ArchiveDir "$(readlink -f .)";
756 CacheDir "$(readlink -f ..)";
757 FileListDir "$(readlink -f pool/)";
b7899b00
DK
758};
759Default {
c5ede4ca
DK
760 Packages::Compress "$COMPRESSORS";
761 Sources::Compress "$COMPRESSORS";
762 Contents::Compress "$COMPRESSORS";
763 Translation::Compress "$COMPRESSORS";
18331adf 764 LongDescription "false";
ce9864a8
DK
765};
766TreeDefault {
767 Directory "pool/";
768 SrcDirectory "pool/";
769};
c5ede4ca 770EOF
b7899b00
DK
771 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
772 echo -n 'tree "dists/' >> ftparchive.conf
773 echo -n "$DIST" >> ftparchive.conf
774 echo -n '" {
ce9864a8
DK
775 Architectures "' >> ftparchive.conf
776 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
777 echo -n 'source";
778 FileList "' >> ftparchive.conf
779 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
780 echo -n '";
781 SourceFileList "' >> ftparchive.conf
782 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
783 echo -n '";
784 Sections "' >> ftparchive.conf
785 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
786 echo '";
ce9864a8 787};' >> ftparchive.conf
b7899b00 788 done
ce9864a8
DK
789}
790
791buildaptftparchivedirectorystructure() {
b7899b00
DK
792 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
793 for DIST in $DISTS; do
794 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
795 for SECTION in $SECTIONS; do
796 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
797 for ARCH in $ARCHS; do
798 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
799 done
800 mkdir -p dists/${DIST}/${SECTION}/source
801 mkdir -p dists/${DIST}/${SECTION}/i18n
802 done
ce9864a8 803 done
ce9864a8
DK
804}
805
9b78cda6 806insertpackage() {
10e100e5 807 local RELEASES="$1"
9b78cda6
DK
808 local NAME="$2"
809 local ARCH="$3"
810 local VERSION="$4"
811 local DEPENDENCIES="$5"
d67004e0 812 local PRIORITY="${6:-optional}"
10e100e5 813 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
18908589
DK
814 If you find such a package installed on your system,
815 something went horribly wrong! They are autogenerated
816 und used only by testcases and surf no other propose…"}"
d67004e0 817 local ARCHS=""
10e100e5
DK
818 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
819 if [ "$RELEASE" = 'installed' ]; then
820 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
821 continue
d67004e0 822 fi
10e100e5
DK
823 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
824 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
825 ARCHS="$(getarchitectures)"
826 else
827 ARCHS="$arch"
828 fi
829 for BUILDARCH in $ARCHS; do
830 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
831 mkdir -p $PPATH
832 local FILE="${PPATH}/Packages"
833 echo "Package: $NAME
d67004e0 834Priority: $PRIORITY
9b78cda6 835Section: other
2c085486 836Installed-Size: 42
c919ad6e 837Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
10e100e5
DK
838 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
839 echo "Version: $VERSION
d67004e0 840Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
10e100e5
DK
841 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
842 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)" >> $FILE
843 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" >> $FILE
844 echo >> $FILE
845 done
d67004e0 846 done
10e100e5
DK
847 mkdir -p aptarchive/dists/${RELEASE}/main/source aptarchive/dists/${RELEASE}/main/i18n
848 touch aptarchive/dists/${RELEASE}/main/source/Sources
849 echo "Package: $NAME
0e0d9919
DK
850Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
851Description-en: $DESCRIPTION
852" >> aptarchive/dists/${RELEASE}/main/i18n/Translation-en
10e100e5 853 done
9b78cda6
DK
854}
855
234675b7
DK
856insertsource() {
857 local RELEASE="$1"
858 local NAME="$2"
859 local ARCH="$3"
860 local VERSION="$4"
861 local DEPENDENCIES="$5"
a8275acf 862 local BINARY="${6:-$NAME}"
234675b7
DK
863 local ARCHS=""
864 local SPATH="aptarchive/dists/${RELEASE}/main/source"
865 mkdir -p $SPATH
866 local FILE="${SPATH}/Sources"
9d2a8a73
DK
867 local DSCFILE="${NAME}_${VERSION}.dsc"
868 local TARFILE="${NAME}_${VERSION}.tar.gz"
234675b7 869 echo "Package: $NAME
a8275acf 870Binary: $BINARY
234675b7
DK
871Version: $VERSION
872Maintainer: Joe Sixpack <joe@example.org>
873Architecture: $ARCH" >> $FILE
874 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
875 echo "Files:
9d2a8a73
DK
876 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) $DSCFILE
877 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) $TARFILE
55ae7a51
MV
878Checksums-Sha256:
879 $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) $DSCFILE
880 $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) $TARFILE
d5dea0be 881" >> $FILE
234675b7
DK
882}
883
dfc2b1be
DK
884insertinstalledpackage() {
885 local NAME="$1"
886 local ARCH="$2"
887 local VERSION="$3"
888 local DEPENDENCIES="$4"
d67004e0 889 local PRIORITY="${5:-optional}"
d4b4e5ea 890 local STATUS="${6:-install ok installed}"
14109555 891 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
18908589
DK
892 If you find such a package installed on your system,
893 something went horribly wrong! They are autogenerated
894 und used only by testcases and surf no other propose…"}"
895
53ea1b56
DK
896 local FILE='rootdir/var/lib/dpkg/status'
897 local INFO='rootdir/var/lib/dpkg/info'
3dcdc1f9 898 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
d67004e0 899 echo "Package: $NAME
d4b4e5ea 900Status: $STATUS
d67004e0 901Priority: $PRIORITY
dfc2b1be
DK
902Section: other
903Installed-Size: 42
904Maintainer: Joe Sixpack <joe@example.org>
dfc2b1be 905Version: $VERSION" >> $FILE
c919ad6e 906 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
d67004e0 907 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
18908589
DK
908 echo "Description: $DESCRIPTION" >> $FILE
909 echo >> $FILE
53ea1b56
DK
910 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
911 echo -n > ${INFO}/${NAME}:${arch}.list
912 else
913 echo -n > ${INFO}/${NAME}.list
914 fi
d67004e0 915 done
dfc2b1be
DK
916}
917
918
ce9864a8 919buildaptarchivefromincoming() {
3cbbda3c 920 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
921 cd aptarchive
922 [ -e pool ] || ln -s ../incoming pool
923 [ -e ftparchive.conf ] || createaptftparchiveconfig
924 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 925 msgninfo "\tGenerate Packages, Sources and Contents files… "
31be38d2 926 testsuccess aptftparchive generate ftparchive.conf
ce9864a8
DK
927 cd - > /dev/null
928 msgdone "info"
4dbfe436 929 generatereleasefiles "$@"
ce9864a8
DK
930}
931
932buildaptarchivefromfiles() {
3cbbda3c 933 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
8d041b4f
DK
934 local DIR='aptarchive'
935 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
936 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
9b78cda6 937 msgninfo "\t${line} file… "
276e51dd 938 compressfile "$line" "$1"
8d876415 939 msgdone "info"
9b78cda6 940 done
e3c62328 941 generatereleasefiles "$@"
9b78cda6
DK
942}
943
276e51dd
DK
944compressfile() {
945 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
946 if [ "$compressor" = '.' ]; then
947 if [ -n "$2" ]; then
948 touch -d "$2" "$1"
949 fi
950 continue
951 fi
952 cat "$1" | $command > "${1}.${extension}"
953 if [ -n "$2" ]; then
954 touch -d "$2" "${1}.${extension}"
955 fi
956 done
957}
958
a3bbbab7 959# can be overridden by testcases for their pleasure
bf9e7447
DK
960getcodenamefromsuite() {
961 case "$1" in
962 unstable) echo 'sid';;
963 *) echo -n "$1";;
964 esac
965}
a3bbbab7 966getreleaseversionfromsuite() { true; }
718f797c 967getlabelfromsuite() { true; }
d56e2917 968getoriginfromsuite() { true; }
a3bbbab7 969
c5ede4ca
DK
970aptftparchiverelease() {
971 aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference
972}
9b78cda6 973generatereleasefiles() {
884a4c0a
DK
974 # $1 is the Date header and $2 is the ValidUntil header to be set
975 # both should be given in notation date/touch can understand
9b78cda6
DK
976 msgninfo "\tGenerate Release files… "
977 if [ -e aptarchive/dists ]; then
978 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
a3bbbab7
DK
979 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
980 local CODENAME="$(getcodenamefromsuite $SUITE)"
981 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 982 local LABEL="$(getlabelfromsuite $SUITE)"
d56e2917 983 local ORIGIN="$(getoriginfromsuite $SUITE)"
884a4c0a 984 if [ -n "$VERSION" ]; then
718f797c
DK
985 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
986 fi
987 if [ -n "$LABEL" ]; then
988 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
a3bbbab7 989 fi
d56e2917
DK
990 if [ -n "$ORIGIN" ]; then
991 ORIGIN="-o APT::FTPArchive::Release::Origin=${ORIGIN}"
992 fi
c5ede4ca 993 aptftparchiverelease $dir \
884a4c0a
DK
994 -o APT::FTPArchive::Release::Suite="${SUITE}" \
995 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
718f797c 996 ${LABEL} \
d56e2917 997 ${ORIGIN} \
884a4c0a 998 ${VERSION} \
c5ede4ca 999 > $dir/Release
a3bbbab7 1000 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11
DK
1001 sed -i '/^Date: / a\
1002NotAutomatic: yes' $dir/Release
1003 fi
9b78cda6
DK
1004 done
1005 else
c5ede4ca 1006 aptftparchiverelease ./aptarchive > aptarchive/Release
8d876415 1007 fi
884a4c0a 1008 if [ -n "$1" -a "$1" != "now" ]; then
fe0f7911 1009 for release in $(find ./aptarchive -name 'Release'); do
c5ede4ca 1010 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $release
fe0f7911
DK
1011 touch -d "$1" $release
1012 done
8d876415 1013 fi
c5ede4ca
DK
1014 if [ -n "$2" ]; then
1015 sed -i "/^Date: / a\
1016Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $(find ./aptarchive -name 'Release')
1017 fi
b7899b00 1018 msgdone "info"
8d876415
DK
1019}
1020
b7899b00
DK
1021setupdistsaptarchive() {
1022 local APTARCHIVE=$(readlink -f ./aptarchive)
1023 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
1024 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
1025 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
1026 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
1027 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
1028 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
1029 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
1030 msgdone "info"
1031 done
1032}
1033
1034setupflataptarchive() {
ce9864a8 1035 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
1036 if [ -f ${APTARCHIVE}/Packages ]; then
1037 msgninfo "\tadd deb sources.list line… "
1038 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
1039 msgdone "info"
1040 else
1041 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
1042 fi
1043 if [ -f ${APTARCHIVE}/Sources ]; then
1044 msgninfo "\tadd deb-src sources.list line… "
1045 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
1046 msgdone "info"
1047 else
1048 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
1049 fi
b7899b00
DK
1050}
1051
1052setupaptarchive() {
4dbfe436
DK
1053 local NOUPDATE=0
1054 if [ "$1" = '--no-update' ]; then
1055 NOUPDATE=1
1056 shift
1057 fi
1058 buildaptarchive "$@"
b7899b00
DK
1059 if [ -e aptarchive/dists ]; then
1060 setupdistsaptarchive
1061 else
1062 setupflataptarchive
1063 fi
9d653a6d 1064 signreleasefiles 'Joe Sixpack'
4dbfe436 1065 if [ "1" != "$NOUPDATE" ]; then
5684f71f 1066 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
b2ea1a47 1067 fi
8d876415
DK
1068}
1069
f213b6ea
DK
1070signreleasefiles() {
1071 local SIGNER="${1:-Joe Sixpack}"
07cb47e7 1072 local REPODIR="${2:-aptarchive}"
f1e1abd8 1073 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
33a22672 1074 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
f1e1abd8 1075 msgninfo "\tSign archive with $SIGNER key $KEY… "
29a59c46
DK
1076 local REXKEY='keys/rexexpired'
1077 local SECEXPIREBAK="${REXKEY}.sec.bak"
1078 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1079 if [ "${SIGNER}" = 'Rex Expired' ]; then
1080 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1081 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1082 # therefore we 'temporary' make the key not expired and restore a backup after signing
1083 cp ${REXKEY}.sec $SECEXPIREBAK
1084 cp ${REXKEY}.pub $PUBEXPIREBAK
1085 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1086 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1087 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
1088 cp $SECUNEXPIRED ${REXKEY}.sec
1089 cp $PUBUNEXPIRED ${REXKEY}.pub
1090 else
f1e1abd8
DK
1091 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1092 cat setexpire.gpg
1093 exit 1
1094 fi
29a59c46
DK
1095 cp ${REXKEY}.sec $SECUNEXPIRED
1096 cp ${REXKEY}.pub $PUBUNEXPIRED
1097 fi
1098 fi
07cb47e7 1099 for RELEASE in $(find ${REPODIR}/ -name Release); do
29a59c46 1100 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
e3c62328 1101 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
29a59c46 1102 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
e3c62328
DK
1103 # we might have set a specific date for the Release file, so copy it
1104 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
f213b6ea 1105 done
29a59c46
DK
1106 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
1107 mv -f $SECEXPIREBAK ${REXKEY}.sec
1108 mv -f $PUBEXPIREBAK ${REXKEY}.pub
1109 fi
f213b6ea
DK
1110 msgdone "info"
1111}
1112
8eafc759
DK
1113redatereleasefiles() {
1114 local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1115 for release in $(find aptarchive/ -name 'Release'); do
1116 sed -i "s/^Date: .*$/Date: ${DATE}/" $release
1117 touch -d "$DATE" $release
1118 done
1119 signreleasefiles "${2:-Joe Sixpack}"
1120}
1121
f2c0ec8b 1122webserverconfig() {
ba6b79bd 1123 local WEBSERVER="${3:-http://localhost:8080}"
b0314abb
DK
1124 local NOCHECK=false
1125 if [ "$1" = '--no-check' ]; then
1126 NOCHECK=true
1127 shift
1128 fi
0d58c26a 1129 local DOWNLOG='rootdir/tmp/download-testfile.log'
b0314abb 1130 local STATUS='downloaded/webserverconfig.status'
0d58c26a 1131 rm -f "$STATUS" "$DOWNLOG"
b0314abb
DK
1132 local URI
1133 if [ -n "$2" ]; then
1134 msgtest "Set webserver config option '${1}' to" "$2"
ba6b79bd 1135 URI="${WEBSERVER}/_config/set/${1}/${2}"
b0314abb
DK
1136 else
1137 msgtest 'Clear webserver config option' "${1}"
ba6b79bd 1138 URI="${WEBSERVER}/_config/clear/${1}"
b0314abb
DK
1139 fi
1140 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
f2c0ec8b
DK
1141 msgpass
1142 else
68042532
DK
1143 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1144 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1145 msgfailoutput '' "$OUTPUT"
f2c0ec8b 1146 fi
b0314abb 1147 $NOCHECK || testwebserverlaststatuscode '200'
f2c0ec8b
DK
1148}
1149
fd46d305
DK
1150rewritesourceslist() {
1151 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
1152 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
b0314abb 1153 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#https://localhost:4433/#${1}#"
fd46d305
DK
1154 done
1155}
1156
5572f6bd
MV
1157# wait for up to 10s for a pid file to appear to avoid possible race
1158# when a helper is started and dosn't write the PID quick enough
1159waitforpidfile() {
1160 local PIDFILE="$1"
1161 for i in $(seq 10); do
1162 if test -s "$PIDFILE"; then
1163 return 0
1164 fi
1165 sleep 1
1166 done
1167 msgdie "waiting for $PIDFILE failed"
1168 return 1
1169}
1170
f213b6ea 1171changetowebserver() {
23af9f40
DK
1172 if [ "$1" != '--no-rewrite' ]; then
1173 rewritesourceslist 'http://localhost:8080/'
1174 else
1175 shift
1176 fi
5c0dd6fc 1177 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
fbd29dd6 1178 cd aptarchive
a0db467c
DK
1179 local LOG="webserver.log"
1180 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
bee0670b
DK
1181 cat $LOG
1182 false
1183 fi
5572f6bd 1184 waitforpidfile aptwebserver.pid
e3c62328
DK
1185 local PID="$(cat aptwebserver.pid)"
1186 if [ -z "$PID" ]; then
1187 msgdie 'Could not fork aptwebserver successfully'
1188 fi
1189 addtrap "kill $PID;"
fbd29dd6 1190 cd - > /dev/null
c5bcc607 1191 else
fbd29dd6 1192 msgdie 'You have to build aptwerbserver or install a webserver'
f213b6ea 1193 fi
fd46d305
DK
1194}
1195
1196changetohttpswebserver() {
1197 if ! which stunnel4 >/dev/null; then
1198 msgdie 'You need to install stunnel4 for https testcases'
1199 fi
1200 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
dc95fee1 1201 changetowebserver --no-rewrite "$@"
fd46d305
DK
1202 fi
1203 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
68ba0b7f 1204cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
23af9f40 1205output = /dev/null
fd46d305
DK
1206
1207[https]
1208accept = 4433
1209connect = 8080
1210" > ${TMPWORKINGDIRECTORY}/stunnel.conf
1211 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
5572f6bd 1212 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
fd46d305 1213 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
5572f6bd
MV
1214 if [ -z "$PID" ]; then
1215 msgdie 'Could not fork stunnel4 successfully'
1216 fi
fd46d305
DK
1217 addtrap 'prefix' "kill ${PID};"
1218 rewritesourceslist 'https://localhost:4433/'
f213b6ea
DK
1219}
1220
c45233ea
DK
1221changetocdrom() {
1222 mkdir -p rootdir/media/cdrom/.disk
1223 local CD="$(readlink -f rootdir/media/cdrom)"
a0975c8d
DK
1224 echo "acquire::cdrom::mount \"${CD}\";
1225acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
1226acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1227acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
c45233ea
DK
1228 echo -n "$1" > ${CD}/.disk/info
1229 if [ ! -d aptarchive/dists ]; then
1230 msgdie 'Flat file archive cdroms can not be created currently'
1231 return 1
1232 fi
a0975c8d 1233 mv aptarchive/dists "$CD"
c45233ea
DK
1234 ln -s "$(readlink -f ./incoming)" $CD/pool
1235 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
a0975c8d
DK
1236 # start with an unmounted disk
1237 mv "${CD}" "${CD}-unmounted"
1238 # we don't want the disk to be modifiable
1239 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
b0314abb 1240 chmod -R 555 rootdir/media/cdrom-unmounted/dists
c45233ea
DK
1241}
1242
fd46d305 1243downloadfile() {
ed793a19 1244 local PROTO="${1%%:*}"
27925d82 1245 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
dcbb364f 1246 download-file "$1" "$2" "$3" 2>&1 ; then
27925d82
DK
1247 return 1
1248 fi
fd46d305 1249 # only if the file exists the download was successful
b0314abb 1250 if [ -r "$2" ]; then
fd46d305
DK
1251 return 0
1252 else
1253 return 1
1254 fi
1255}
1256
f213b6ea 1257checkdiff() {
03aa0847 1258 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
8d876415 1259 if [ -n "$DIFFTEXT" ]; then
0d58c26a
DK
1260 echo >&2
1261 echo >&2 "$DIFFTEXT"
8d876415
DK
1262 return 1
1263 else
1264 return 0
1265 fi
1266}
1267
22ac12b2
DK
1268testoutputequal() {
1269 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output"
1270 local COMPAREFILE="$1"
1271 shift
1272 if "$@" 2>&1 | checkdiff $COMPAREFILE - >"$OUTPUT" 2>&1; then
1273 msgpass
1274 else
1275 echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}"
1276 cat "$COMPAREFILE" >>"${OUTPUT}"
1277 msgfailoutput '' "$OUTPUT" "$@"
1278 fi
1279}
1280
75954ae2 1281testfileequal() {
1501a2c9 1282 msggroup 'testfileequal'
e6a12ff7
DK
1283 local MSG='Test for correctness of file'
1284 if [ "$1" = '--nomsg' ]; then
1285 MSG=''
1286 shift
1287 fi
75954ae2
DK
1288 local FILE="$1"
1289 shift
e6a12ff7
DK
1290 if [ -n "$MSG" ]; then
1291 msgtest "$MSG" "$FILE"
1292 fi
68042532 1293 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
75954ae2 1294 if [ -z "$*" ]; then
22ac12b2 1295 testoutputequal "$FILE" echo -n ''
75954ae2 1296 else
22ac12b2 1297 testoutputequal "$FILE" echo "$*"
75954ae2 1298 fi
9beb11aa 1299 msggroup
75954ae2
DK
1300}
1301
b855a400 1302testempty() {
1501a2c9 1303 msggroup 'testempty'
b855a400 1304 msgtest "Test for no output of" "$*"
859093da 1305 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
921a9626 1306 if ("$@" >$COMPAREFILE 2>&1 || true) && test ! -s $COMPAREFILE; then
859093da
DK
1307 msgpass
1308 else
22ac12b2 1309 msgfailoutput '' "$COMPAREFILE" "$@"
859093da 1310 fi
ab25bf1f 1311 aptautotest 'testempty' "$@"
9beb11aa 1312 msggroup
b855a400
DK
1313}
1314
f74a6fa1 1315testequal() {
1501a2c9 1316 msggroup 'testequal'
f74a6fa1
DK
1317 local MSG='Test of equality of'
1318 if [ "$1" = '--nomsg' ]; then
1319 MSG=''
1320 shift
1321 fi
1322
03938280 1323 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
8d876415
DK
1324 echo "$1" > $COMPAREFILE
1325 shift
d2d68aaf 1326
f74a6fa1
DK
1327 if [ -n "$MSG" ]; then
1328 msgtest "$MSG" "$*"
1329 fi
22ac12b2 1330 testoutputequal "$COMPAREFILE" "$@"
ab25bf1f 1331 aptautotest 'testequal' "$@"
9beb11aa 1332 msggroup
8d876415
DK
1333}
1334
685625bd 1335testequalor2() {
1501a2c9 1336 msggroup 'testequalor2'
03938280
DK
1337 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1338 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1339 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
685625bd
DK
1340 echo "$1" > $COMPAREFILE1
1341 echo "$2" > $COMPAREFILE2
1342 shift 2
1343 msgtest "Test for equality OR of" "$*"
ab25bf1f 1344 "$@" >$COMPAREAGAINST 2>&1 || true
0d58c26a
DK
1345 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1346 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1347 then
0caa5a4c
DK
1348 msgpass
1349 else
68042532
DK
1350 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1351 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1352 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1353 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1354 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1355 msgfailoutput '' "$OUTPUT"
0caa5a4c 1356 fi
ab25bf1f 1357 aptautotest 'testequalor2' "$@"
9beb11aa 1358 msggroup
685625bd
DK
1359}
1360
8d876415 1361testshowvirtual() {
1501a2c9 1362 msggroup 'testshowvirtual'
edc0ef10 1363 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1364 local PACKAGE="$1"
1365 shift
1366 while [ -n "$1" ]; do
1367 VIRTUAL="${VIRTUAL}
edc0ef10 1368N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1369 PACKAGE="${PACKAGE} $1"
1370 shift
1371 done
1372 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1373 VIRTUAL="${VIRTUAL}
4bec02c2 1374N: No packages found"
03938280 1375 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
ea65d079 1376 local ARCH="$(getarchitecture 'native')"
68042532
DK
1377 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1378 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
22ac12b2 1379 testoutputequal "$COMPAREFILE" aptcache show -q=0 "$PACKAGE"
9beb11aa 1380 msggroup
8d876415
DK
1381}
1382
1383testnopackage() {
1501a2c9 1384 msggroup 'testnopackage'
8d876415 1385 msgtest "Test for non-existent packages" "apt-cache show $*"
846856f4 1386 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
8d876415 1387 if [ -n "$SHOWPKG" ]; then
68042532
DK
1388 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1389 echo "$SHOWPKG" >"$OUTPUT"
1390 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1391 else
1392 msgpass
8d876415 1393 fi
9beb11aa 1394 msggroup
8d876415 1395}
01a6e24c 1396
ecb777dd 1397testdpkgstatus() {
1501a2c9 1398 msggroup 'testdpkgstatus'
ecb777dd
DK
1399 local STATE="$1"
1400 local NR="$2"
1401 shift 2
1402 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1403 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1404 if [ "$PKGS" != $NR ]; then
68042532
DK
1405 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1406 echo "$PKGS" >"$OUTPUT"
1407 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1408 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1409 else
1410 msgpass
01a6e24c 1411 fi
9beb11aa 1412 msggroup
01a6e24c
DK
1413}
1414
ecb777dd 1415testdpkginstalled() {
1501a2c9 1416 msggroup 'testdpkginstalled'
ecb777dd 1417 testdpkgstatus 'ii' "$#" "$@"
9beb11aa 1418 msggroup
ecb777dd
DK
1419}
1420
5cf733e1 1421testdpkgnotinstalled() {
1501a2c9 1422 msggroup 'testdpkgnotinstalled'
ecb777dd 1423 testdpkgstatus 'ii' '0' "$@"
9beb11aa 1424 msggroup
01a6e24c 1425}
ec7f904e
DK
1426
1427testmarkedauto() {
1501a2c9 1428 msggroup 'testmarkedauto'
03938280 1429 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
ec7f904e
DK
1430 if [ -n "$1" ]; then
1431 msgtest 'Test for correctly marked as auto-installed' "$*"
1432 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1433 else
1434 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 1435 echo -n > $COMPAREFILE
ec7f904e 1436 fi
22ac12b2 1437 testoutputequal "$COMPAREFILE" aptmark showauto
9beb11aa 1438 msggroup
ec7f904e 1439}
7c2cc4a7 1440testmarkedmanual() {
1501a2c9 1441 msggroup 'testmarkedmanual'
7c2cc4a7
DK
1442 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1443 if [ -n "$1" ]; then
1444 msgtest 'Test for correctly marked as manually installed' "$*"
1445 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1446 else
1447 msgtest 'Test for correctly marked as manually installed' 'no package'
1448 echo -n > $COMPAREFILE
1449 fi
22ac12b2 1450 testoutputequal "$COMPAREFILE" aptmark showmanual
9beb11aa 1451 msggroup
7c2cc4a7 1452}
89a1aa5d 1453
e52aad52 1454msgfailoutput() {
1501a2c9 1455 msgreportheader 'msgfailoutput'
e52aad52
DK
1456 local MSG="$1"
1457 local OUTPUT="$2"
1458 shift 2
e52aad52 1459 if [ "$1" = 'grep' ]; then
68042532 1460 echo >&2
e52aad52
DK
1461 while [ -n "$2" ]; do shift; done
1462 echo "#### Complete file: $1 ####"
1463 cat >&2 "$1" || true
1464 echo '#### grep output ####'
1465 elif [ "$1" = 'test' ]; then
68042532 1466 echo >&2
e52aad52
DK
1467 # doesn't support ! or non-file flags
1468 msgfailoutputstatfile() {
1469 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1470 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1471 echo "#### stat(2) of file: $2 ####"
1472 stat "$2" || true
3196dae8
DK
1473 if test -e "$2"; then
1474 echo "#### Complete file: $2 ####"
1475 cat >&2 "$2" || true
1476 fi
e52aad52
DK
1477 fi
1478 }
1479 msgfailoutputstatfile "$2" "$3"
1480 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1481 shift 3
1482 msgfailoutputstatfile "$2" "$3"
1483 done
1484 echo '#### test output ####'
1485 fi
1486 cat >&2 $OUTPUT
1487 msgfail "$MSG"
1488}
1489
0440d936 1490testsuccess() {
1501a2c9 1491 msggroup 'testsuccess'
0440d936
DK
1492 if [ "$1" = '--nomsg' ]; then
1493 shift
1494 else
1495 msgtest 'Test for successful execution of' "$*"
1496 fi
03938280 1497 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
4fa34122
DK
1498 if "$@" >${OUTPUT} 2>&1; then
1499 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1500 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1501 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
3261271e
DK
1502 elif grep -E '^[WE]: ' "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
1503 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1504 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1505 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1506 msgpass
1507 else
1508 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1509 fi
1510 else
1511 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1512 fi
4fa34122
DK
1513 else
1514 msgpass
1515 fi
1516 else
1517 msgpass
1518 fi
1519 else
1520 local EXITCODE=$?
e52aad52 1521 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
4fa34122
DK
1522 fi
1523 aptautotest 'testsuccess' "$@"
9beb11aa 1524 msggroup
4fa34122
DK
1525}
1526testwarning() {
1501a2c9 1527 msggroup 'testwarning'
4fa34122
DK
1528 if [ "$1" = '--nomsg' ]; then
1529 shift
1530 else
1531 msgtest 'Test for successful execution with warnings of' "$*"
1532 fi
25b86db1 1533 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
1df24acf
DK
1534 if "$@" >${OUTPUT} 2>&1; then
1535 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1536 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1537 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1538 elif grep -q -E '^E: ' "$OUTPUT"; then
1539 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
4fa34122 1540 elif ! grep -q -E '^W: ' "$OUTPUT"; then
e52aad52 1541 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1df24acf
DK
1542 else
1543 msgpass
1544 fi
1545 else
1546 msgpass
1547 fi
0440d936 1548 else
07cb47e7 1549 local EXITCODE=$?
68042532 1550 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1551 fi
4fa34122 1552 aptautotest 'testwarning' "$@"
9beb11aa 1553 msggroup
0440d936 1554}
0440d936 1555testfailure() {
1501a2c9 1556 msggroup 'testfailure'
0440d936
DK
1557 if [ "$1" = '--nomsg' ]; then
1558 shift
1559 else
889b0072 1560 msgtest 'Test for failure in execution of' "$*"
0440d936 1561 fi
03938280 1562 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1df24acf 1563 if "$@" >${OUTPUT} 2>&1; then
07cb47e7 1564 local EXITCODE=$?
e52aad52 1565 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1566 else
1df24acf
DK
1567 local EXITCODE=$?
1568 if expr match "$1" '^apt.*' >/dev/null; then
b0d40854
DK
1569 if [ "$1" = 'aptkey' ]; then
1570 if grep -q -E " Can't check signature: " "$OUTPUT" || \
1571 grep -q -E " BAD signature from " "$OUTPUT"; then
1572 msgpass
1573 else
1574 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1575 fi
1df24acf 1576 else
b0d40854
DK
1577 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1578 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1579 elif grep -q -E '==ERROR' "$OUTPUT"; then
1580 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1581 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1582 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1583 else
1584 msgpass
1585 fi
1df24acf
DK
1586 fi
1587 else
1588 msgpass
1589 fi
0440d936 1590 fi
ab25bf1f 1591 aptautotest 'testfailure' "$@"
9beb11aa 1592 msggroup
0440d936
DK
1593}
1594
7414af7f
DK
1595testreturnstateequal() {
1596 local STATE="$1"
1597 msggroup "${STATE}equal"
1598 if [ "$2" != '--nomsg' ]; then
1599 local CMP="$2"
1600 shift 2
1601 "$STATE" "$@"
1602 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1603 else
1604 local CMP="$3"
1605 shift 3
1606 "$STATE" --nomsg "$@"
1607 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1608 fi
9beb11aa 1609 msggroup
25b86db1 1610}
7414af7f
DK
1611testsuccessequal() {
1612 testreturnstateequal 'testsuccess' "$@"
1613}
25b86db1 1614testwarningequal() {
7414af7f 1615 testreturnstateequal 'testwarning' "$@"
25b86db1
DK
1616}
1617testfailureequal() {
7414af7f 1618 testreturnstateequal 'testfailure' "$@"
25b86db1
DK
1619}
1620
27925d82 1621testfailuremsg() {
1501a2c9 1622 msggroup 'testfailuremsg'
27925d82
DK
1623 local CMP="$1"
1624 shift
1625 testfailure "$@"
1626 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
68042532
DK
1627 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
1628 grep '^\(W\|E\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
22ac12b2 1629 testoutputequal "$COMPAREFILE" echo "$CMP"
9beb11aa 1630 msggroup
27925d82 1631}
25b86db1 1632
de81b2e2 1633testfilestats() {
1501a2c9 1634 msggroup 'testfilestats'
de81b2e2
DK
1635 msgtest "Test that file $1 has $2 $3" "$4"
1636 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
5684f71f
DK
1637 msgpass
1638 else
68042532
DK
1639 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1640 {
1641 ls -ld "$1" || true
1642 echo -n "stat(1) reports for $2: "
1643 stat --format "$2" "$1" || true
1644 } >"$OUTPUT" 2>&1
1645 msgfailoutput '' "$OUTPUT"
5684f71f 1646 fi
9beb11aa 1647 msggroup
5684f71f 1648}
de81b2e2 1649testaccessrights() {
1501a2c9 1650 msggroup 'testaccessrights'
de81b2e2 1651 testfilestats "$1" '%a' '=' "$2"
9beb11aa 1652 msggroup
de81b2e2 1653}
5684f71f 1654
0d58c26a 1655testwebserverlaststatuscode() {
1501a2c9 1656 msggroup 'testwebserverlaststatuscode'
0d58c26a 1657 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
03aa0847 1658 local STATUS='downloaded/webserverstatus-statusfile.log'
0d58c26a
DK
1659 rm -f "$DOWNLOG" "$STATUS"
1660 msgtest 'Test last status code from the webserver was' "$1"
b0314abb 1661 if downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
0d58c26a
DK
1662 msgpass
1663 else
68042532
DK
1664 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1665 {
1666 if [ -n "$2" ]; then
1667 shift
1668 echo >&2 '#### Additionally provided output files contain:'
1669 cat >&2 "$@"
1670 fi
1671 echo >&2 '#### Download log of the status code:'
1672 cat >&2 "$DOWNLOG"
1673 } >"$OUTPUT" 2>&1
1674 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
0d58c26a 1675 fi
9beb11aa 1676 msggroup
0d58c26a
DK
1677}
1678
89a1aa5d
DK
1679pause() {
1680 echo "STOPPED execution. Press enter to continue"
1681 local IGNORE
1682 read IGNORE
1683}
ab25bf1f 1684
846bc058 1685listcurrentlistsdirectory() {
ba6b79bd
DK
1686 {
1687 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1688 stat --format '%U:%G:%a:%n' "$line"
1689 done
1690 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1691 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1692 done
1693 } | sort
846bc058
DK
1694}
1695
3a8776a3 1696### convenience hacks ###
8fe964f1
DK
1697mkdir() {
1698 # creating some directories by hand is a tedious task, so make it look simple
1699 if [ "$*" = '-p rootdir/var/lib/apt/lists' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" ] ||
1700 [ "$*" = '-p rootdir/var/lib/apt/lists/partial' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" ]; then
1701 # only the last directory created by mkdir is effected by the -m !
1702 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1703 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1704 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1705 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1706 if [ "$(id -u)" = '0' ]; then
1707 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1708 fi
1709 else
1710 command mkdir "$@"
1711 fi
1712}
1713
ab25bf1f
DK
1714### The following tests are run by most test methods automatically to check
1715### general things about commands executed without writing the test every time.
1716
1717aptautotest() {
1718 local TESTCALL="$1"
1719 local CMD="$2"
1720 local FIRSTOPT="$3"
1721 local AUTOTEST="aptautotest_$(basename "$CMD" | tr -d '-')_$(echo "$FIRSTOPT" | tr -d '-')"
1722 if command -v $AUTOTEST >/dev/null; then
1723 shift 3
1724 # save and restore the *.output files from other tests
1725 # as we might otherwise override them in these automatic tests
03aa0847
DK
1726 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1727 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1728 mkdir ${TMPWORKINGDIRECTORY}/rootdir/tmp
ab25bf1f 1729 $AUTOTEST "$TESTCALL" "$@"
03aa0847
DK
1730 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1731 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1732 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp-before ${TMPWORKINGDIRECTORY}/rootdir/tmp
ab25bf1f
DK
1733 fi
1734}
1735
1736aptautotest_aptget_update() {
59148d96
DK
1737 local TESTCALL="$1"
1738 while [ -n "$2" ]; do
1739 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1740 shift
1741 done
ab25bf1f 1742 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
4bb006d1
DK
1743 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1744 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
ab25bf1f 1745 # all copied files are properly chmodded
146f7715 1746 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
4bb006d1 1747 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
ab25bf1f 1748 done
59148d96 1749 if [ "$TESTCALL" = 'testsuccess' ]; then
146f7715
DK
1750 # failure cases can retain partial files and such
1751 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1752 fi
ab25bf1f
DK
1753}
1754aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
d84da499 1755aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
016bea82
DK
1756
1757testaptautotestnodpkgwarning() {
1758 local TESTCALL="$1"
1759 while [ -n "$2" ]; do
6bf93605
DK
1760 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1761 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
016bea82
DK
1762 shift
1763 done
1764 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1765}
1766
1767aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1768aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1769aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1770aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1771aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1772aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }